
const { PDFDocument, StandardFonts, rgb } = PDFLib;



async function fillForm(loc) {
  const formUrl = loc;
  const formPdfBytes = await fetch(formUrl).then(res => res.arrayBuffer())

  const path = loc.replace(/\/[^/]+\/?$/, '');
  const star0 = path+'/assets/stars0.png'
  const star0ImageBytes = await fetch(star0).then(res => res.arrayBuffer())
  const star1 = path+'/assets/stars1.png'
  const star1ImageBytes = await fetch(star1).then(res => res.arrayBuffer())
  const star2 = path+'/assets/stars2.png'
  const star2ImageBytes = await fetch(star2).then(res => res.arrayBuffer())
  const star3 = path+'/assets/stars3.png'
  const star3ImageBytes = await fetch(star3).then(res => res.arrayBuffer())

  //const emblemUrl = 'https://pdf-lib.js.org/assets/mario_emblem.png'
  //const emblemImageBytes = await fetch(emblemUrl).then(res => res.arrayBuffer())

  const pdfDoc = await PDFDocument.load(formPdfBytes)

  let starImage = [];
  starImage.push(await pdfDoc.embedPng(star0ImageBytes))
  starImage.push(await pdfDoc.embedPng(star1ImageBytes))
  starImage.push(await pdfDoc.embedPng(star2ImageBytes))
  starImage.push(await pdfDoc.embedPng(star3ImageBytes))
  
  const form = pdfDoc.getForm()

  const nameField = form.getTextField('txtTitle');
  const rulesTitle = form.getTextField('txtRules01');
  const rulesAttr = form.getTextField('txtRules01Attr');
  const rulesQs = form.getTextField('txtRules01Qs');

  const enviroTitle = form.getTextField('txtEnv02');
  const enviroAttr = form.getTextField('txtEnv02Attr');
  const enviroQs = form.getTextField('txtEnv02Qs');

  const fictionTitle = form.getTextField('txtFiction03');
  const fictionAttr = form.getTextField('txtFiction03Attr');
  const fictionQs = form.getTextField('txtFiction03Qs');

  const immersionTitle = form.getTextField('txtImmersion04');
  const immersionAttr = form.getTextField('txtImmersion04Attr');
  const immersionQs = form.getTextField('txtImmersion04Qs');


  const conflictTitle = form.getTextField('txtConflict05');
  const conflictAttr = form.getTextField('txtConflict05Attr');
  const conflictQs = form.getTextField('txtConflict05Qs');


  const actionTitle = form.getTextField('txtAction06');
  const actionAttr = form.getTextField('txtAction06Attr');
  const actionQs = form.getTextField('txtAction06Qs');

  
  const assessmentTitle = form.getTextField('txtAssess07');
  const assessmentAttr = form.getTextField('txtAssess07Attr');
const assessmentQs = form.getTextField('txtAssess07Qs');

  const controlTitle = form.getTextField('txtControl08');
  const controlAttr = form.getTextField('txtControl08Attr');
  const controlQs = form.getTextField('txtControl08Qs');

  const humanTitle = form.getTextField('txtHuman09');
  const humanAttr = form.getTextField('txtHuman09Attr');
  const humanQs = form.getTextField('txtHuman09Qs');

  const ph1Title = form.getTextField('txtPh1Title');
  const ph1Description = form.getTextField('txtPh1Description');
  const ph1Qs = form.getTextField('txtPh1Qs');

  const ph2Title = form.getTextField('txtPh2Title');
  const ph2Description = form.getTextField('txtPh2Description');
  const ph2Qs = form.getTextField('txtPh2Qs');

  const ph3Title = form.getTextField('txtPh3Title');
  const ph3Description = form.getTextField('txtPh3Description');
  const ph3Qs = form.getTextField('txtPh3Qs');

  const ph4Title = form.getTextField('txtPh4Title');
  const ph4Description = form.getTextField('txtPh4Description');
  const ph4Qs = form.getTextField('txtPh4Qs');

  let imageField = [];
  for (i = 1; i<=9; i++)
  {
  imageField.push(form.getButton('btnCat'+i))
  }
  
  let player = GetPlayer();
  let gtx = [];
  gtx.push("")
  let sltitle = player.GetVar("pdfTitle");
  let pdfdoc = (sltitle != "" && sltitle !== null) ? sltitle +".pdf" : "default_title.pdf"; 
  
  for (let i=1; i<=9; i++)
  {
    gtx.push(player.GetVar("gtx0"+i))
   }

  let gph01 = player.GetVar("gph01");
  let gph02 = player.GetVar("gph02");
  let gph03 = player.GetVar("gph03");
  let gph04 = player.GetVar("gph04");

  ph1Title.setText("Phase 1: DISCOVERY");
  ph1Description.setText("Goal: intrigue. \nFeeling:'Hmm... Maybe I should check this out!'");
  ph1Qs.setText(gph01);

  ph2Title.setText("Phase 2: ONBOARDING");
  ph2Description.setText("Goal: buy-in. \nFeeling: 'I am here. Now what?' ");
  ph2Qs.setText(gph02);

  ph3Title.setText("Phase 2: SCAFFOLDING");
  ph3Description.setText("Goal: flow (challenges just above the player's head). \nFeeling: 'Bring it on!' ");
  ph3Qs.setText(gph03);  

  ph4Title.setText("Phase 2: ENDGAME/MASTERY");
  ph4Description.setText("Goal: CCTA (celebrate & call to action). \nFeeling: 'Congrats to me! What now? Is there a Season 2?' ");
  ph4Qs.setText(gph04);






  nameField.setText('Deliberate Play: '+player.GetVar("gTitle"));
  
  rulesTitle.setText('Rules & Goals: Rules, goals, and information (including the core loop) that enable players to progress and reach goals.');
  rulesAttr.setText('Attributes: rules, goals, and the core loop.');
  rulesQs.setText(
    [
      `- What is the goal of the game? Does the game explicitly state the goal?`,
      `- How does a player win? How does the player know the end state of the game?`,
      `- What are some of the main rules of the game? How does the game present rules?`,
      `- What’s the core loop (the fundamental activity repeated throughout the game)?`,
      `- How does the core loop change (difficulty or complexity) over time?\n`,
      gtx[1],
    ].join('\n'),
  )


  enviroTitle.setText('Representation of the physical surroundings in which the player is immersed, also known as the game world.');
  enviroAttr.setText('Attribute: location.');
  enviroQs.setText(
    [
      `- Where is the player in the game?`,
      `- How does the player experience that world?\n`,
      gtx[2],
    ].join('\n'),
  )

  fictionTitle.setText('The nature of the game world and story.');
  fictionAttr.setText('Attributes: fantasy and mystery, with fantasy referring to elements that are disparate from the real world and mystery as the gap between known and unknown information.');
  fictionQs.setText(
    [
     `- Where is the game world on the scale from realistic to fantastic?`,
      `- Does the player know the nature of the world, or must the player figure that out?\n`,
      gtx[3],
    ].join('\n'),
  )

  immersionTitle.setText('The player’s perceptual and affective relationship with the game fiction.');
  immersionAttr.setText('Attributes: pieces and players, representation, sensory stimuli, and safety.');
  immersionQs.setText(
    [
     `- How do the players see themselves in the game? What is the representation of the play in the game world?`,
    `- What are the visual and auditory aspects of the game world?`,
    `- What pieces and other players are included in the gameplay? Are they active (they can interact with the player) or passive?`,
    `- What failure can the player experience and learn in the game world that would not be possible in the real world?\n`,
      gtx[4],
    ].join('\n'),
  )

  conflictTitle.setText('Both the presentation of problems in a game as well as the nature and difficulty of such problems.');
  conflictAttr.setText('Attributes: adaptation, challenge, conflict, and surprise; the difficulty of the game (the challenge); the nature of the problems (the conflict); the degree of uncertainty in the definition of these problems (the surprise).');
  conflictQs.setText(
    [
     `- What type of challenge is the player facing? How difficult is it to tackle?`,
    `- What surprise elements does the player notice? How much information gap does the player gain in the problem definitions (from clear to a total mystery)?`,
    `- How does the game change its difficulty and complexity based on the player’s actions (adaptation)?\n`,
      gtx[5],
    ].join('\n'),
  )

  actionTitle.setText('Specific communication rules of the game between the player and the system.');
  actionAttr.setText('Attributes: language and communication.');
  actionQs.setText(
    [
     `- How and when does the system communicate with the player?`,
      `- How does the player interact and communicate with the system?\n`,
      gtx[6],
    ].join('\n'),
  )

  assessmentTitle.setText('The nature and content of any feedback, such as debriefings, given to the player during the game.');
  assessmentAttr.setText('Attributes: assessment (the measurement of achievement, such as scoring, within the game); progress (how the player advances toward game goals).');
  assessmentQs.setText(
    [
     `- How does the player know how they are doing in terms of achievement? (score)`,
    `- How does the player progress against game goals? (progress)\n`,
      gtx[7],
    ].join('\n'),
  )

  controlTitle.setText('The degree of interaction and agency the player is capable of in the game.');
  controlAttr.setText('Attribute: control and interaction (equipment).');
  controlQs.setText(
    [
     `- How much control does the player have over the content or gameplay?`,
    `- How does the game change in response to the player’s action?\n`,
      gtx[8],
    ].join('\n'),
  )

  humanTitle.setText('Any human-to-human contact involved in the game.');
  humanAttr.setText('Attributes: interpersonal and social interaction.');
  humanQs.setText(
    [
     `- Does the player interact directly with other human players within the game?`,
    `- Does the player interact socially (such as via social media or an external platform) with other human players in the game?\n`,
      gtx[9],
    ].join('\n'),
  )



  let star = 0;
  for (i=1; i<=9; i++)
   { 
    star = parseInt(player.GetVar("Cat"+i+"Value"));
    imageField[i-1].setImage(starImage[star])
   }
  
  const pdfBytes = await pdfDoc.save()

  // Trigger the browser to download the PDF document
      download(pdfBytes, pdfdoc, "application/pdf");
}
